/***************************************************************************
                          box.h  -  description
                             -------------------
    begin                : Thu Feb 21 2002
    copyright            : (C) 2002 by Gene Ruebsamen
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef BOX_H
#define BOX_H
#include <ode/ode.h>
#include <drawstuff/drawstuff.h>
#include "creature.h"

class Box : public Creature {
public:
	Box(dWorldID,dSpaceID,dReal,dReal,dReal,bool=false);		// constructor (world,space,x,y,z,in,hid,out,recur)
	~Box();	// destructor
	void draw(bool=false) const;
	void getInputs(float *) const;
	const dReal * getHeadPos(void) const;
	const dReal * getBodyRot(void) const;
	const float getFitness(void) const;
	void setMuscles(const float * const);
	void footContact(dGeomID,dGeomID,dGeomID);   		// are the feet touching the ground
	void bodyContact(dGeomID,dGeomID,dGeomID);			// has body touched the ground?
	void randomForce(void) const;
	void randomTorque(void) const;
	bool hasFallen(void) const;
	void shutoff(void);
  void clearSensor(void);
  void printStats(void) const;
private:
	void constructBody(dWorldID,dSpaceID,dReal,dReal,dReal);
	const int numBody;
	const int numGeom;
	const int numJoint;
	bool l_foot_sens;
	bool r_foot_sens;
	dBodyID *body;
	dGeomID *geom;
	dJointID *joint;
	dJointGroupID jGroup;
	dGeomID geomGroup;
	//  declarations
	dReal TORSO[3]; 	// length, width height
	dReal LEG1[3];	
	dReal LEG2[3];	
	dReal LEG3[3];
	dReal GAP;
};

#endif

