/***************************************************************************
                          creature.h  -  description
                             -------------------
    begin                : Mon Feb 18 2002
    copyright            : (C) 2002 by Gene Ruebsamen
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CREATURE_H
#define CREATURE_H
#include <ode/ode.h>

class Creature {
	friend class Human;								// declare Human as a friend class
	friend class SimpleHuman;
	friend class EasyHuman;
	friend class Box;
	friend class Hopper;
	friend class Hexapod;
  friend class Runner;
public:
	Creature(dWorldID, dSpaceID, dReal, dReal, dReal);		// constructor (bodies, geometries, joints)
	virtual ~Creature();	// destructor
	virtual void draw(bool) const=0;
	const dReal getStartX(void) const;
	const dReal getStartY(void) const;
	const dReal getStartZ(void) const;

private:
	dWorldID world;
	dSpaceID space;
	dReal startx;
	dReal starty;
	dReal startz;
};

#endif
