/***************************************************************************
                          human.h  -  description
                             -------------------
    begin                : Mon Feb 18 2002
    copyright            : (C) 2002 by Gene Ruebsamen
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef HUMAN_H
#define HUMAN_H
#include <ode/ode.h>
#include <drawstuff/drawstuff.h>
#include "creature.h"

class Human : public Creature {
public:
	Human(dWorldID,dSpaceID,dReal,dReal,dReal);		// constructor (world,space,x,y,z)
	~Human();	// destructor
	void draw(bool=false) const;
	void getInputs(float *) const;
	const dReal * getHeadPos(void) const;
	const dReal * getLFootPos(void) const;
	const dReal * getRFootPos(void) const;
	float getFitness(void) const;
	void shutoff(void);
	void setMuscles(const float * const);
	void footContact(dGeomID,dGeomID,dGeomID);   		// are the feet touching the ground
	void bodyContact(dGeomID,dGeomID,dGeomID);			// has body touched the ground?
	void randomForce(void) const;
	void randomTorque(void) const;
	bool hasFallen(void) const;
private:
	const int numBody;
	const int numGeom;
	const int numJoint;
	bool l_foot_sens;
	bool r_foot_sens;
	bool body_sens;
	bool fallen;
	dBodyID *body;
	dGeomID *geom;
	dJointID *joint;
	dJointGroupID jGroup;
	dGeomID geomGroup;
	//  declarations
	dReal HEAD;
	dReal TORSO[3]; 	// length, width height
	dReal ARM1[3];
	dReal ARM2[3];
	dReal LEG1[3];	
	dReal LEG2[3];	
	dReal FOOT[3];
	dReal GAP;
};

#endif
